from handlers.HandlerBase import BaseHandler
from model.log import logger
from data_manage.pitcher_panel import *
log = logger()


class PitcherPanelChannel(BaseHandler):

    def post(self):
        pitcher = self.get_argument("pitcher", '')
        channel = self.get_argument("channel", '')
        start = self.get_argument("start", du.get_n_days(-1))
        end = self.get_argument("end", du.get_n_days(-1))
        date_range = self.get_argument("date_range", '')
        page = self.get_argument("page",'1')
        page_size = self.get_argument("page_size",'10')
        order_by=self.get_argument("order_by",'date')
        order=self.get_argument("order", 'desc')
        if date_range!='':
            end=du.get_n_days(-1)
            start=du.get_n_days(-int(date_range))

        data=get_pitcher_panel_channel(pitcher, channel, start, end, page, page_size, order_by, order)
        self.write_json(data)


class PitcherPanelDaily(BaseHandler):
    def post(self):
        pitcher = self.get_argument("pitcher", '')
        start = self.get_argument("start", du.get_n_days(-1))
        end = self.get_argument("end", du.get_n_days(-1))
        date_range = self.get_argument("date_range", '')
        page = self.get_argument("page", '1')
        page_size = self.get_argument("page_size", '10')
        order_by = self.get_argument("order_by", 'date')
        order = self.get_argument("order", 'desc')
        if date_range != '':
            end = du.get_n_days(-1)
            start = du.get_n_days(-int(date_range))

        data = get_pitcher_panel_daily(pitcher, start, end, page, page_size, order_by, order)
        self.write_json(data)


class PitcherPanelOverview(BaseHandler):
    def post(self):
        args=self.get_args()
        pitcher = args.get("pitcher", '')
        data = get_pitcher_panel_overview(pitcher)
        self.write_json(data)